<template>
  <div>
    <div v-if="!this.pipelineEnd">
      <section class="hero is-success is-fullheight">
        <div class="hero-body">
          <div class="container">
            <h1 class="title">
              wait for process to end
            </h1>
            <progress
              class="progress is-info"
              v-bind:value="this.remaining"
              v-bind:max="this.total"
            ></progress>
          </div>
        </div>
      </section>
    </div>
    <div v-else-if="!this.rendering">
      <section class="hero is-success is-fullheight">
        <div class="hero-body">
          <div class="container">
            <h1 class="title">
              Pipeline finish waiting rendering
            </h1>
            <progress class="progress is-info"></progress>
          </div>
        </div>
      </section>
    </div>
    <div v-else>
      <resumePipeline v-bind:data="this.repos" />
      <div>
        <allReposViewer v-bind:data="this.allLogs" />
      </div>
      <div v-if="this.logs != {}">
        <reposViewer v-bind:data="this.logs" />
      </div>
      <div v-if="this.analyse != null">
        <analyseViewer v-bind:data="this.analyse" />
      </div>
    </div>
  </div>
</template>

<script>
import analyseViewer from "@/components/viewer/analyseViewer";
import reposViewer from "@/components/viewer/reposViewer";
import allReposViewer from "@/components/viewer/allReposViewer";
import resumePipeline from "@/components/viewer/resumePipeline";

export default {
  name: "PipelineRenderer",
  components: {
    analyseViewer,
    reposViewer,
    allReposViewer,
    resumePipeline
  },
  props: {
    pipeline: Object
  },
  data: function() {
    return {
      pipelineEnd: false,
      remaining: 0,
      total: this.pipeline.numberOfTasks,
      analyse: null,
      logs: {},
      allLogs: [],
      rendering: false,
      repos: new Map()
    };
  },
  created() {
    var next = this.getPipelineResults;
    var pipeline = this.pipeline;
    pipeline.user = this.$store.state.auth.user.email;
    var setRemaning = this.setRemaning;
    var total = this.total;
    var ws = new WebSocket("ws:192.168.99.100:40510");
    // event emmited when connected
    ws.onopen = function() {
      // sending a send event to websocket server
      ws.send(
        `${pipeline.user}|${pipeline.name}|${pipeline.version}|${pipeline.date}`
      );
    };
    // event emmited when receiving message
    ws.onmessage = function(ev) {
      let remaining = total - parseInt(ev.data);
      setRemaning(remaining);
      if (ev.data == 0) {
        next();
      }
    };
    //setTimeout(this.getProgress, 5000);
  },
  methods: {
    setRemaning(newValue) {
      this.remaining = newValue;
    },
    getProgress() {
      this.$store
        .dispatch("pipeline/getProgress", this.pipeline)
        .then(progress => {
          this.remaining = this.total - progress.remaining;
          if (!progress.remaining) {
            this.pipelineEnd = true;
            this.getPipelineResults();
            return Promise.resolve();
          } else {
            setTimeout(this.getProgress(), 500);
          }
        });
    },
    getPipelineResults() {
      this.pipelineEnd = true;
      this.$store
        .dispatch("pipeline/getResults", this.pipeline)
        .then(results => {
          // eslint-disable-next-line no-unused-vars
          for (const [key, value] of Object.entries(results)) {
            if (value != "") {
              let datas = JSON.parse(value);
              for (const [key, data] of Object.entries(datas)) {
                switch (key) {
                  case "analyse":
                    this.analyse = data;
                    for (let [language, value] of Object.entries(data)) {
                      for (let dependance of value) {
                        let repo = dependance.path.split(/\//g)[1];
                        // eslint-disable-next-line no-prototype-builtins
                        if (!this.repos.has(repo)) {
                          this.repos.set(repo, new Map());
                        }
                        if (!this.repos.get(repo).has(language)) {
                          this.repos.get(repo).set(language, []);
                        }
                        this.repos
                          .get(repo)
                          .get(language)
                          .push({
                            path: dependance.path,
                            dependance: dependance.dependency
                          });
                      }
                    }
                    break;
                  case "log":
                    for (const [key, data] of Object.entries(data)) {
                      this.logs[key] = data;
                      this.allLogs.push.apply(this.allLogs, data);
                    }
                    break;
                  case "clone":
                    if (!this.repos.has(data)) {
                      this.repos.set(data, []);
                    }
                    break;
                  default:
                    console.log("default case should not reach this point");
                }
              }
            }
          }
          this.rendering = true;
        });
    }
  }
};
</script>
